package cn.com.tenlion.systembase.service.comprehensivecenter;

import cn.com.tenlion.systembase.pojo.bos.comprehensivecenter.ComprehensiveCenterBO;
import cn.com.tenlion.systembase.pojo.dtos.comprehensivecenter.ComprehensiveCenterDTO;
import cn.com.tenlion.systembase.pojo.pos.comprehensivecenter.ComprehensiveCenterPO;
import cn.com.tenlion.systembase.pojo.vos.comprehensivecenter.ComprehensiveCenterVO;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IComprehensiveCenterService
 * @Description: 综治中心
 * @Author: CodeFactory
 * @Date: 2021-10-12 15:24:00
 * @Version: 3.0
 **/
public interface IComprehensiveCenterService {

    /**
     * 新增综治中心
     *
     * @param comprehensiveCenterVO
     * @return
     */
    void save(ComprehensiveCenterVO comprehensiveCenterVO);

    /**
     * 新增综治中心
     *
     * @param token
     * @param comprehensiveCenterVO
     * @return
     */
    void save(String token, ComprehensiveCenterVO comprehensiveCenterVO);

    /**
     * 新增综治中心
     *
     * @param comprehensiveCenterVO
     * @return comprehensiveCenterId
     */
    String saveReturnId(ComprehensiveCenterVO comprehensiveCenterVO);

    /**
     * 新增综治中心
     *
     * @param token
     * @param comprehensiveCenterVO
     * @return comprehensiveCenterId
     */
    String saveReturnId(String token, ComprehensiveCenterVO comprehensiveCenterVO);

    /**
     * 删除综治中心
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids, String idsStr);


    /**
     * 删除综治中心
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids, String idsStr);

    /**
     * 删除综治中心（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改综治中心
     *
     * @param comprehensiveCenterId
     * @param comprehensiveCenterVO
     * @return
     */
    void update(String comprehensiveCenterId, ComprehensiveCenterVO comprehensiveCenterVO);

    /**
     * 修改综治中心
     *
     * @param token
     * @param comprehensiveCenterId
     * @param comprehensiveCenterVO
     * @return
     */
    void update(String token, String comprehensiveCenterId, ComprehensiveCenterVO comprehensiveCenterVO);

    /**
     * 综治中心详情
     *
     * @param params 参数Map
     * @return
     */
    ComprehensiveCenterDTO get(Map<String, Object> params);

    /**
     * 综治中心详情
     *
     * @param comprehensiveCenterId
     * @return
     */
    ComprehensiveCenterDTO get(String comprehensiveCenterId);

    /**
     * 综治中心详情
     *
     * @param params 参数Map
     * @return
     */
    ComprehensiveCenterBO getBO(Map<String, Object> params);

    /**
     * 综治中心详情
     *
     * @param comprehensiveCenterId
     * @return
     */
    ComprehensiveCenterBO getBO(String comprehensiveCenterId);

    /**
     * 综治中心详情
     *
     * @param params 参数Map
     * @return
     */
    ComprehensiveCenterPO getPO(Map<String, Object> params);

    /**
     * 综治中心详情
     *
     * @param comprehensiveCenterId
     * @return
     */
    ComprehensiveCenterPO getPO(String comprehensiveCenterId);

    /**
     * 综治中心列表
     *
     * @param params
     * @return
     */
    List<ComprehensiveCenterDTO> list(Map<String, Object> params);

    /**
     * 综治中心列表
     *
     * @param params
     * @return
     */
    List<ComprehensiveCenterBO> listBO(Map<String, Object> params);

    /**
     * 综治中心列表
     *
     * @param params
     * @return
     */
    List<ComprehensiveCenterPO> listPO(Map<String, Object> params);

    /**
     * 综治中心分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<ComprehensiveCenterDTO>> listPage(ListPage page);

    /**
     * 综治中心统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

    void saveKafka(String uid, ComprehensiveCenterVO comprehensiveCenterVO);

    void updateKafka(String uid, ComprehensiveCenterVO comprehensiveCenterVO);

    void deleteKafka(String uid);

}